spool 3_3_4_DissenyFisic_CreacioTaules.log

--APLICACIÓ--
	CREATE TABLE CLIENT 
		( idClient numeric(10) not null,
		  nomClient Varchar2(20) not null,
		  llinatge1Client Varchar2(20),
		  llinatge2Client Varchar2(20),
		  dataNaixementClient date,
		  sexeClient Varchar2(1), --E (Empresa), M (Masculí), F (Femení)
		  dniCifClient Varchar2(20) not null,
		  telefonClient numeric(15) not null,
		  dataAlta date not null,
		  CONSTRAINT client_pk PRIMARY KEY (idClient)
		);


	CREATE TABLE VENEDOR 
		( idVenedor numeric(10) not null,
		  nomVenedor Varchar2(20) not null,
		  llinatge1Venedor Varchar2(20) not null,
		  llinatge2Venedor Varchar2(20) not null,
		  telefonVenedor numeric(15) not null,
		  dataAlta date not null,
		  CONSTRAINT venedor_pk PRIMARY KEY (idVenedor)
		);


	CREATE TABLE MARCA
		( idMarca numeric(10) not null,
		  nomMarca Varchar2(20) not null,
		  CONSTRAINT marca_pk PRIMARY KEY (idMarca)
		);


	CREATE TABLE MODEL 
		( idModel numeric(10) not null,
		  nomModel varchar2(20) not null,
		  preuModel number(10,2) not null,
		  potenciaModel number(3) not null,
		  numPortesModel number(1) not null,
		  cilindradaModel number (4,3),
		  combustibleModel varchar2(10) not null,
		  idMarca	numeric(10) not null,
		  CONSTRAINT model_pk PRIMARY KEY (idModel),
		  CONSTRAINT fk_model
		    FOREIGN KEY (idMarca)
                   REFERENCES Marca (idMarca)
		);
	
	
	CREATE TABLE COTXE
		( idCotxe numeric(10) not null,
		  bastidorCotxe Varchar2(20) not null unique,
		  matriculaCotxe Varchar2(20),
		  idModel numeric(10) not null,
		  CONSTRAINT cotxe_pk PRIMARY KEY (idCotxe),
		  CONSTRAINT fk_cotxe
		    FOREIGN KEY (idModel)
                   REFERENCES model(idModel)
		);

	CREATE TABLE COTXESVENDA 
		( idCotxe numeric(10) not null,
		  dataEntradaCotxe date not null,
		  nouSegonaMa varchar2(1), -- 'N' de Nou o 'S' de Segonama
		  preuSegonaMa number(9,2),
		  dataPrimeraMatriculacio date,
		  CONSTRAINT cotxesvenda_pk PRIMARY KEY (idCotxe),
		  CONSTRAINT fk_cotxesvenda
		    FOREIGN KEY (idCotxe)
                   REFERENCES cotxe (idCotxe)
		);

	CREATE TABLE COTXESTALLER 
		( idCotxe numeric(10) not null,
		  idClient numeric(10) not null,
		  CONSTRAINT fk_cotxestaller1
		    FOREIGN KEY (idCotxe)
                   REFERENCES cotxe (idCotxe),
          CONSTRAINT fk_cotxestaller2
		    FOREIGN KEY (idClient)
                   REFERENCES client (idClient)
		);

	CREATE TABLE EXTRA 
		( idExtra numeric(10) not null,
		  nomExtra Varchar2(20) not null,
		  CONSTRAINT extra_pk PRIMARY KEY (idExtra)
		);

	CREATE TABLE EXTRAMODEL
		( idExtra numeric(10) not null,
		  idModel numeric(10) not null,
		  preuExtra number(9,2) not null,
		  serieOpcio Varchar2(1) not null,
		  CONSTRAINT fk_extramodelserie1
		    FOREIGN KEY (idExtra)
                   REFERENCES extra(idExtra),
    	  CONSTRAINT fk_extramodelserie2
		    FOREIGN KEY (idModel)
                   REFERENCES model(idModel)
		);
		
	CREATE TABLE RESERVA
		( idReserva numeric(10) not null,
		  idModel numeric(10) not null,
		  idClient numeric(10) not null,
		  idVenedor numeric(10) not null,
		  preuReserva number (9,2) not null,
		  dataReserva date not null,
		  dataArribadaVehicle date,
		  CONSTRAINT reserva_pk PRIMARY KEY (idReserva),
		  CONSTRAINT fk_reserva1
		    FOREIGN KEY (idModel)
                   REFERENCES model(idModel),
    		  CONSTRAINT fk_reserva2
		    FOREIGN KEY (idClient)
                   REFERENCES client(idClient),
    		  CONSTRAINT fk_reserva3
		    FOREIGN KEY (idVenedor)
                   REFERENCES venedor(idVenedor)
		);


	CREATE TABLE VENDA
		( idVenda numeric(10) not null,
		  idCotxe numeric(10) not null,
		  idClient numeric(10) not null,
		  idVenedor numeric(10) not null,
		  preuVenda number (9,2) not null,
		  dataVenda date not null,
		  idReserva numeric(10),
		  CONSTRAINT venda_pk PRIMARY KEY (idVenda),
		  CONSTRAINT fk_venda1
		    FOREIGN KEY (idCotxe)
            REFERENCES cotxe(idCotxe),
    	  CONSTRAINT fk_venda2
		    FOREIGN KEY (idClient)
			REFERENCES client(idClient),
		  CONSTRAINT fk_venda3
		    FOREIGN KEY (idVenedor)
                   REFERENCES venedor(idVenedor),
          CONSTRAINT fk_venda4
		    FOREIGN KEY (idReserva)
                   REFERENCES reserva(idReserva)
		);
		
	
	CREATE TABLE EXTRACOTXE
		( idExtra numeric(10) not null,
		  idCotxe numeric(10) not null,
		  CONSTRAINT fk_extracotxe1
		    FOREIGN KEY (idExtra)
                   REFERENCES extra(idExtra),
    		  CONSTRAINT fk_extracotxe2
		    FOREIGN KEY (idCotxe)
                   REFERENCES cotxe(idCotxe)
		);


	CREATE TABLE EXTRAAFEGITRESERVA
		( idReserva numeric(10) not null,
		  idExtra numeric(10) not null,
		  CONSTRAINT fk_extraafegitreserva1
		    FOREIGN KEY (idExtra)
                   REFERENCES extra(idExtra),
    		  CONSTRAINT fk_extraafegitreserva2
		    FOREIGN KEY (idReserva)
                   REFERENCES reserva(idReserva)
		);
	
	
	CREATE TABLE REVISIO
		( idRevisio numeric(10) not null,
		  idCotxe numeric(10) not null,
		  dataRevisio date not null,
		  motiu Varchar2(1000),
		  esPressupost Varchar2(1),
		  CONSTRAINT revisio_pk PRIMARY KEY (idRevisio),
		  CONSTRAINT fk_revisio
		    FOREIGN KEY (idCotxe)
                   REFERENCES cotxe(idCotxe)
		);

	CREATE TABLE REPARACIO
		( idReparacio numeric(10) not null,
		  idCotxe numeric(10) not null,
		  dataIniciReparacio date not null,
		  dataFiReparacio date,
		  motiu Varchar2(1000),
		  costPecesReparacio number(9,2),
		  esPressupost Varchar2(1),
		  CONSTRAINT reparacio_pk PRIMARY KEY (idReparacio),
		  CONSTRAINT fk_reparacio
		    FOREIGN KEY (idCotxe)
                   REFERENCES cotxe(idCotxe)
		);


	CREATE TABLE CATEGORIAMECANIC
		( idCategoriaMecanic numeric(10) not null,
		  nomCategoriaMecanic Varchar2(20) not null,
		  preuHoraCategoriaMecanic number (9,2) not null,
		  CONSTRAINT categoriamecanic_pk PRIMARY KEY (idCategoriaMecanic)
		);

		
	CREATE TABLE MECANIC
		( idMecanic numeric(10) not null,
		  nomMecanic Varchar2(20) not null,
		  llinatge1Mecanic Varchar2(20) not null,
		  llinatge2Mecanic Varchar2(20),
		  idCategoriaMecanic numeric not null,
		  CONSTRAINT mecanic_pk PRIMARY KEY (idMecanic),
		  CONSTRAINT fk_mecanic
		    FOREIGN KEY (idCategoriaMecanic)
            REFERENCES CategoriaMecanic(idCategoriaMecanic)
		);


	CREATE TABLE HAREPARAT
		( idReparacio numeric(10) not null,
		  idMecanic numeric(10) not null,
		  numHoresReparacio numeric(10) not null,
		  preuHoresReparacio number(9,2),
		  CONSTRAINT hareparat_pk PRIMARY KEY (idReparacio,idMecanic),
		  CONSTRAINT fk_hareparat1
		    FOREIGN KEY (idReparacio)
                   REFERENCES reparacio(idReparacio),
		  CONSTRAINT fk_hareparat2
		    FOREIGN KEY (idMecanic)
                   REFERENCES mecanic(idMecanic)
		);

	
	CREATE TABLE HAREVISAT
		( idRevisio numeric(10) not null,
		  idMecanic numeric(10) not null,
		  numHoresRevisio numeric(10) not null,
		  preuHoresRevisio number(9,2),
		  CONSTRAINT harevisat_pk PRIMARY KEY (idRevisio,IdMecanic),
		  CONSTRAINT fk_harevisat1
		    FOREIGN KEY (idRevisio)
                   REFERENCES revisio(idRevisio),
		  CONSTRAINT fk_harevisat2
		    FOREIGN KEY (idMecanic)
                   REFERENCES mecanic(idMecanic)
		);


--MÒDUL DE DATAWAREHOUSE--
	--DIMENSIONS--
	CREATE TABLE dData 
		( idData numeric(8),
		  dataAny numeric(4),
		  mesAny numeric(2),
		  diaAny numeric(2),
		  CONSTRAINT ddata_pk PRIMARY KEY (idData));		

	CREATE TABLE dCLIENT 
		( idClient numeric(10) not null,
		  sexeClient numeric(1) not null, --0 Masculi, 1 Femeni, 2 Empresa -> <2 equival als que no són empreses
		  CONSTRAINT dclient_pk PRIMARY KEY (idClient)
		);

	CREATE TABLE dVENEDOR 
		( idVenedor numeric(10) not null,
		  CONSTRAINT dvenedor_pk PRIMARY KEY (idVenedor)
		);

	--FETS--
	CREATE TABLE TempsReparacioCotxe
		( idData numeric(8),
		  tempsMitjanaReparacio number(10,2),
		  CONSTRAINT trc_pk PRIMARY KEY(idData),
		  CONSTRAINT fk_trc
		   FOREIGN KEY (idData)
                   REFERENCES dData(idData));


	CREATE TABLE RanquingVenedor
		( idData numeric(8),
		  idVenedor numeric(10),
		  venda number(10,2),
		  CONSTRAINT rv_pk PRIMARY KEY(idData,idVenedor),
		  CONSTRAINT fk_rv1
		   FOREIGN KEY (idData)
                   REFERENCES dData(idData),
          CONSTRAINT fk_rv2
		   FOREIGN KEY (idVenedor)
                   REFERENCES dVenedor(idVenedor)
          );


	CREATE TABLE AgrupatRevisio
		( idData numeric(8),
		  numRevisio integer,
		  CONSTRAINT arv_pk PRIMARY KEY(idData),
		  CONSTRAINT fk_mr
		   FOREIGN KEY (idData)
                   REFERENCES dData(idData));


	CREATE TABLE AgrupatReparacio
		( idData numeric(8),
		  numReparacio integer,
		  CONSTRAINT arp_pk PRIMARY KEY(idData),
		  CONSTRAINT fk_mrp
		   FOREIGN KEY (idData)
                   REFERENCES dData(idData));


	CREATE TABLE AgrupatVenda
		( idData numeric(8),
		  numVendes integer,
		  CONSTRAINT av_pk PRIMARY KEY(idData),
		  CONSTRAINT fk_mv
		   FOREIGN KEY (idData)
                   REFERENCES dData(idData));


	CREATE TABLE DespesaClient
		( idClient numeric(8),
		  idData numeric(8),
		  sumVendes number(10,2),
		  CONSTRAINT dc_pk PRIMARY KEY(idClient,idData),
		  CONSTRAINT fk_dc1
		   FOREIGN KEY (idClient)
                   REFERENCES dClient(idClient),
          CONSTRAINT fk_dc2
		   FOREIGN KEY (idData)
                   REFERENCES dData(idData));
                   
    CREATE TABLE CONTROL_DWH
		( procediment Varchar2(50) not null,
		  data_inicial_darrera_execucio date,
		  data_final_darrera_execucio date,
		  data_execucio date,
		  CONSTRAINT controldwh_pk PRIMARY KEY(procediment)
		);



--MODUL DE CONTROL--
	CREATE TABLE LOG_PROC_EXECUCIO
		( idLog numeric(10) not null,
		  procedimentLog Varchar2(50) not null,
          parametresLog Varchar2(100) not null,
          CONSTRAINT lpe_pk  PRIMARY KEY (idLog)
		);
		
	CREATE TABLE LOG_SEG_EXECUCIO
		( idLog numeric(10) not null,
		  dataLog date not null,
		  operacio Varchar2(200) not null,
		  CONSTRAINT fk_lse
			FOREIGN KEY (idLog)
				REFERENCES LOG_PROC_EXECUCIO(idLog)
		);

	CREATE TABLE CONFIGURACIO_SISTEMA
		( parametre Varchar2(20) not null,
                 valor Varchar2(20) not null,
                 CONSTRAINT cs_pk PRIMARY KEY (parametre)
		);

spool off;
